var pkgInfo = require('./package.json');
var Service = require('webos-service');
var service = new Service("com.lg.app.signage.signagelivesyncsservice");
//service.activityManager.idleTimeout = 36000;  //unit is second

var WebSocketServer = require('websocket').server;
var dgram = require("dgram");
var http = require('http');

service.register('serverOn', function(message) {
	try {
		onServer(message);
		message.respond({
			returnValue : true
		});
	} catch(err) {
		message.respond({
			returnValue : false,
			errorCode : 'NO_SERVER',
			errorText : 'Cannot run server',
			errorMessage: err.message
		});
	}
});

var keepAliveInterval = null;
var onServer = function(message) {
	
	var server = http.createServer();
	var io = require('socket.io')(server);
	
	io.on('connection', function (socket) {
		  socket.on('message', function (msg) 
		  {
			  if(msg==="close")
			  {
				  io.close();
				  clearInterval(keepAliveInterval);
			  }
		  });
		  socket.on('disconnect', function () { });
		  
		  socket.on('sync', function (data) 
		  {
			  io.sockets.emit('syncevent',data);
		  });
	});
	
	//Seperate signal to tell slaves the master is running
	keepAliveInterval = setInterval(function()
	{
		io.sockets.emit('masteralive');
	},message.payload.keepAliveInterval);
	
	server.listen(9990, function() { });
};

var broadcastListeningServer = null;
service.register("receive", function(message) {
	try {
		
		broadcastListeningServer = dgram.createSocket("udp4");
		 
		 broadcastListeningServer.on("message", function (msg, rinfo) {	
			 message.respond({
			  	 returnValue: true,
			  	 data: msg.toString()
			 });
	     });	
		 
		 broadcastListeningServer.bind(41234);

 
	} catch(err) {
	    console.log(err.message); 
	    
		message.respond({
			returnValue : false,
			errorCode : 'ERROR',
			errorText : err.message
		});
	}
}, function(message) {
	//Cancel
	try {
		broadcastListeningServer.close();
	} catch(err)
	{
		
	}
});


service.register("setupReceiveServer", function(message) {
	 
	try {
		setupReceiver2();
		
		message.respond({
			returnValue: true
		});
 
	} catch(err) {
    
		message.respond({
			returnValue : false,
			errorCode : 'ERROR',
			errorText : err.message
		});
	}

}
,function(message)
{

});


var setupReceiver2 = function()
{
	//var broadcastListeningServer = null;
	var server = http.createServer();
	var io = require('socket.io')(server);
	
	io.on('connection', function (socket) {
		  socket.on('message', function (msg) 
		  {
			  if(msg==="close")
			  {
				  if(broadcastListeningServer != null)
					  broadcastListeningServer.close();
				  
				  io.close();
			  }
		  });
		  socket.on('disconnect', function () { }); 
	});
	
	server.listen(19990, function() { });
	

	broadcastListeningServer = dgram.createSocket("udp4");
	 
	broadcastListeningServer.on("message", function (msg, rinfo) {	
		 io.sockets.emit('masterbroadcast',msg.toString());
	 });
	 
	broadcastListeningServer.bind(41234);
};



service.register("broadcast", function(message) {
	console.log("broadcast");
	
	var client = dgram.createSocket("udp4");
	
	var broadcastObject = {};
	broadcastObject.ipAddress = message.payload.ipAddress;
	broadcastObject.syncGroup = message.payload.syncGroup;
	
	//Create a JSON string of the object containing the IP address and sync group ID
	var broadcastMessage = JSON.stringify(broadcastObject);
	
	
	client.on('listening', function(){
		console.log("Port is listening, do the broadcast");
		client.setBroadcast(true);
		client.send(broadcastMessage, 0, broadcastMessage.length, 41234, "255.255.255.255",function(err,bytes)
				{
					console.log("Broadcast sent");
					client.close();
					
					message.respond({
						returnValue: true,
						message: "done"
					});
				});
	});
	
	client.bind(41235);

});



