define(["properties/App.Settings","properties/App.Properties","system/power/PowerInterface","system/SystemInterface","system/io/FileEx","system/io/Directory","models/RebootReasons"],function(e,i,t,o,a,r,n){return function(){function l(){var t,o;logger.info("Checking if application update is required..."),e.application.sdkVersion<1.2?(logger.warning("WARNING: Client does not support SCAP 1.2. Using AJAX to request XML file. This may result in inode count increase. Please update the firmware to a version that supports SCAP 1.2."),$.ajax({url:e.application.remoteApplicationUpdates.location+e.application.remoteApplicationUpdates.configFileName,contentType:"application/xml",timeout:1e4,cache:!1}).done(function(e,t,o){$(e).find("application version").first().text();var a=$(e).find("application buildnumber").first().text();$(e).find("application name").first().text(),a!=i.appBuildNumber?(logger.info("Application update: REQUIRED. Current version: "+i.appBuildNumber+". New version: "+a),s(a)):logger.info("Application update: NOT REQUIRED. Current version: "+i.appBuildNumber+". New version: "+a)}).fail(function(e,i,t){logger.error("Error retrieving update file "+t)})):(logger.info("SCAP 1.2 Supported. Downloading XML config and checking for update..."),t=e.application.remoteApplicationUpdates.location+e.application.remoteApplicationUpdates.configFileName,o=e.application.fileSystem.root+"/"+e.application.remoteApplicationUpdates.configFileName,logger.info("App Updater: Downloading XML Config File from: "+t+" to "+o),(new Storage).copyFile(function(e){logger.info("App Updater: Downloaded XML Config File: "+o),(new Storage).readFile(function(e){var t=e.data;logger.info("App Updater: Successfully read XML Data from local: "+t);var o=$.parseXML(t),a=($(o).find("application version").first().text(),$(o).find("application buildnumber").first().text());$(o).find("application name").first().text(),a!=i.appBuildNumber?(logger.info("Application update: REQUIRED. Current version: "+i.appBuildNumber+". New version: "+a),s(a)):logger.info("Application update: NOT REQUIRED. Current version: "+i.appBuildNumber+". New version: "+a)},function(i){logger.error("App Updated: Error whilst reading XML Config File from: "+o+". Error: ["+e.errorCode+"] "+e.errorText)},{path:o,encoding:"utf8",position:0})},function(e){logger.error("App Updated: Error whilst downloading XML Config File from: "+t+". Error: ["+e.errorCode+"] "+e.errorText)},{source:t,destination:o}))}function p(e,i){var t=$.Deferred();return i?a.write(e,i):(setTimeout(function(){t.resolve()},50),t)}function s(e){var i=$.Deferred(),o={to:Storage.AppMode.LOCAL,recovery:!0};return(new Storage).upgradeApplication(function(i){logger.info("Application updated successfully. Attempting restart..."),t.reboot(n.APPLICATION_UPDATE,e)},function(e){logger.error("Failed to update application: ["+e.errorCode+"] "+e.errorText),i.reject()},o),i}this.start=function(){var i;logger.info("App Update process started."),(i=$.Deferred(),logger.info("Checking if IPK upgrade is required"),e.application.webOSVersion<=2?(logger.warning("IPK Upgade not supported for supported for model "+e.application.model+" with webOS version "+e.application.webOSVersion+". Application will continue to run as a zip package. Some advanced application feature such as support for synchronisation will be unavailable."),setTimeout(function(){i.resolve(!1)},100)):o.getServerProperties().done(function(e){if(!e.appType||"zip"!=e.appType&&"ZIP"!=e.appType){logger.info("IPK Upgrade not required.");try{logger.info("Server settings appType: "+e.appType)}catch(e){}i.resolve(!1)}else logger.info("IPK Upgrade required"),i.resolve(!0)}).fail(function(){logger.error("Unable to determine if IPK upgrade is required - failed to load server properties"),i.resolve(!1)}),i).done(function(i){i?(logger.info("Updated server settings to IPK format."),logger.info("Copying data files from local storage to file system..."),a.read(e.application.fileSystem.systemFiles.settingsFilePath).done(function(i){a.read(e.application.fileSystem.systemFiles.clientIdFilePath).done(function(t){a.read(e.application.fileSystem.systemFiles.clientKeyFilePath).done(function(o){a.read(e.application.fileSystem.systemFiles.lastConfigFilePath).done(function(n){a.read(e.application.fileSystem.systemFiles.fileListFilePath).done(function(a){if(a){var l=JSON.parse(localStorage[e.application.fileSystem.systemFiles.fileListFilePath]);l.forEach(function(e){0===e.path.lastIndexOf("data/",0)&&(e.path=e.path.replace("data/","file://internal/data/"))}),a=JSON.stringify(l)}e.application.packageType="IPK",e.application.fileSystem.dataDirectory="data",logger.info("Creating data directory"),r.createDirectory(e.application.fileSystem.root+"/"+e.application.fileSystem.dataDirectory).always(function(){e.application.fileSystem.systemFiles.settingsFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.settingsFilePath,e.application.fileSystem.systemFiles.propertiesFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.propertiesFilePath,e.application.fileSystem.systemFiles.lastConfigFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.lastConfigFilePath,e.application.fileSystem.systemFiles.clientIdFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.clientIdFilePath,e.application.fileSystem.systemFiles.clientKeyFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.clientKeyFilePath,e.application.fileSystem.systemFiles.appVersionFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.appVersionFilePath,e.application.fileSystem.systemFiles.fileListFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.fileListFilePath,e.application.fileSystem.systemFiles.fileListUpgradeFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.fileListUpgradeFilePath,e.application.fileSystem.systemFiles.proofOfPlayFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.proofOfPlayFilePath,e.application.fileSystem.systemFiles.proofOfPlayUploadFilePath=e.application.fileSystem.root+"/"+e.application.fileSystem.systemFiles.proofOfPlayUploadFilePath,p(e.application.fileSystem.systemFiles.settingsFilePath,i).done(function(){p(e.application.fileSystem.systemFiles.clientIdFilePath,t).done(function(){p(e.application.fileSystem.systemFiles.clientKeyFilePath,o).done(function(){p(e.application.fileSystem.systemFiles.lastConfigFilePath,n).done(function(){p(e.application.fileSystem.systemFiles.fileListFilePath,a).done(function(){logger.info("Updating server settings to switch to IPK format....");var i={serverIp:"192.168.0.2",serverPort:80,secureConnection:!1};i.appLaunchMode=Configuration.AppMode.LOCAL,i.appType="ipk",i.fqdnMode=!0,i.fqdnAddr=e.application.remoteApplicationUpdates.location+"com.lg.app.signage.ipk";var t=new Configuration;t.setServerProperty(function(){logger.info("Copying data files from local storage to file system..."),s().fail(function(){e.application.packageType="ZIP",i.fqdnAddr=e.application.remoteApplicationUpdates.location+"lgapp.zip",i.appType="zip",t.setServerProperty(function(){logger.info("Reverted server settings")},function(){var e=cbObject.errorCode,i=cbObject.errorText;logger.error("Error setting server settings. Error Code ["+e+"]: "+i)},i)})},function(){var e=cbObject.errorCode,i=cbObject.errorText;logger.error("Error setting server settings. Error Code ["+e+"]: "+i)},i)})})})})})})})})})})})):setTimeout(function(){l(),setInterval(l,e.application.remoteApplicationUpdates.frequency)},3e4)})}}});