define(["properties/App.Settings","properties/App.Properties","system/io/File","system/io/Directory","models/ConfigurationModel","models/ObjectProcessingQueueModel","models/ConnectivityIntervalSchemeModel","models/MediaTypeConstants","system/DateTime","models/SystemReportModel","controllers/UserMessageController","models/RssChannelCache","models/RssChannelModel","controllers/RealTimeEventsController","models/DeviceInfoModel","core/SLAPIMethodsInterface","models/API","system/network/NetworkInterface","core/DSSAPIInterface","controllers/ZeroTouchConfigurationController","system/power/PowerInterface","models/RebootReasons"],function(e,t,n,i,o,a,r,s,l,c,u,f,d,g,p,m,y,h,v,w,I,D){return function(t,d){var S,T,A,C,P=this,b=1e4,M=6e4,k=5e3,x=6e4,E=6e4,R=E,F=36e5,j=0;P.lastConnectionTime=null;var _,L=new Date(1970,0,1),N=!1,O=[],U=new m;function H(){logger.info("Checking API for device support"),u.postMessage("Confirming device support");var t=new p;t.generate().done(function(){var n=ae("device",{type:"POST",contentType:"application/json",data:t,beforeSend:function(t,n){t.setRequestHeader("X-SIGNAGELIVE-APP-ID",e.application.api.appId),t.setRequestHeader("X-SIGNAGELIVE-CLIENT-ID",e.application.api.clientId)}});null!=n?n.done(function(e,n,i){switch(P.lastConnectionTime=new Date,e.result){case 1:G();break;case 2:u.postMessage(e.message),setTimeout(H,M);break;case 3:u.postMessage("A client update is required."),setTimeout(H,M);break;case 0:u.postMessage("This device is not supported.\nManufacturer: "+t.manufacturer+"&nbsp;&nbsp;&nbsp;Model: "+t.model),setTimeout(H,M)}}).fail(function(e,t,n){logger.error("Error connecting with Signagelive. Retrying..."),U.deviceSupportCheckAPICallFailed(),setTimeout(H,b)}):(logger.error("Error connecting with Signagelive. Retrying..."),U.deviceSupportCheckAPICallFailed(),setTimeout(H,b))})}function G(){logger.info("Register with Signagelive API "+e.application.api.clientId),u.postMessage("Registering with Signagelive");var t=ae("register",{type:"POST"});null!=t?t.done(function(t,n,i){P.lastConnectionTime=new Date,e.application.api.clientKey=t.client_key,null!=S&null!=S&&S(t.client_key),z(),ue()}).fail(function(e,t,n){409==e.status?A():U.registerAPICallFailed(),de(this.url,this.data,e.status,n,e.responseText),setTimeout(G,k)}):(logger.error("Error registing with Signagelive. Retrying..."),U.registerAPICallFailed(),setTimeout(G,k))}function q(){return U.authenticate(y.PLAYER_API)}function z(){N?setTimeout(z,x):re()?q().done(function(e){e?K():J()}):K()}function K(){try{logger.info("Checking for a configuration update"),U.executeAPICall(y.PLAYER_API,"configuration",{type:"HEAD",contentType:"application/json"}).done(function(t,n,i){P.lastConnectionTime=new Date;var o,r=new Date(i.getResponseHeader("Last-Modified"));if(r.getTime()!=L.getTime()){var s=(o=$.Deferred(),re()?q().done(function(e){e?V().done(function(){o.resolve()}).fail(function(){o.reject()}):o.reject()}):V().done(function(){o.resolve()}).fail(function(){o.reject()}),o);logger.debug("Configuration changed"),s.done(function(){L=r}).fail(function(){}).always(function(){J()})}else logger.debug("Configuration unchanged"),null==C&&null==C||C(),e.application.features.canDownloadFiles?function(){logger.debug("Sync External Media Assets");var e=$.Deferred(),t=new a;return $(O).each(function(e,n){t.push(n)}),X(t,!1).done(function(){e.resolve()}).fail(function(){e.reject()}),e}().always(function(){J()}):J()}).fail(function(t,n,i){401==t.status?(e.application.api.authTokenExpiry=null,setTimeout(z,3e4)):J()})}catch(e){logger.error("Exception trying to perform content check."),J()}}function V(){var t=$.Deferred();u.postMessage("Getting player configuration");var i=ae("configuration"),r="";return i.done(function(i,s,l){_=new o(i),r=i,w.configure(r).then(function(i){r.settings&&r.settings.usePMModeForScreenManagement&&e.application.webOSVersion>=4.1&&I.getPMMode().then(function(e){"screenOffAlways"!==e&&I.setPMMode().then(function(){logger.info("PM Mode set to screenOffAlways")})}),_.connectivity.healthCheckInterval!=R&&(logger.debug("Setting health check interval to "+_.connectivity.healthCheckInterval),R=_.connectivity.healthCheckInterval,clearTimeout(j),te()),g.updateConfiguration(_),function(t){u.postMessage("Downloading content"),N=!0;var n=!1,i=$.Deferred();if(e.application.features.canDownloadFiles){var o=function(e){var t=[];return $(e.schedules).each(function(e,n){var i=!1;n.layout.isDownloaded,0==$.grep(t,function(e,t){return e.externalId==n.layout.externalId}).length&&(i=!0),i&&t.push(n.layout)}),$(e.interrupts).each(function(e,n){0==$.grep(t,function(e,t){return e.externalId==n.action.layout.externalId}).length&&t.push(n.action.layout)}),t}(t),r=new a(o);(function(e){var t=$.Deferred();return function e(t,n){if(0!=t.items.length){var i=t.currentItem();logger.info("Layout Download Start "+i.name),se(i.externalId);var o=new a,r=new a;null!=i.backgroundAsset&&r.push(i.backgroundAsset),$(i.zones).each(function(e,t){null!=t.backgroundAsset&&r.push(t.backgroundAsset),null!=t.seperatorAsset&&r.push(t.seperatorAsset),null!=t.defaultMediaAsset&&r.push(t.defaultMediaAsset),null!=t.defaultPlaylist&&o.push(t.defaultPlaylist),$(t.scheduledPlaylists).each(function(e,t){var n=$.grep(o.items,function(e,n){return e.externalId==t.playlist.externalId}).length;0==n&&o.push(t.playlist)})}),Q(o).done(function(e){var n=t.shift();t.processedItems.push(n),logger.info("Layout Download Complete "+n.name),le(n.externalId)}).fail(function(e,n){var i=t.shift();t.failedItems.push(i),logger.error("Layout Download Failed "+i.name),ce(i.externalId)}).always(function(){X(r,!0).done(function(){}).fail(function(){}).always(function(){setTimeout(function(){e(t,n)},500)})})}else 0==t.failedItems.length?n.resolve(t.processedItems):n.reject(t.processedItems,t.failedItems)}(e,t),t.promise()})(r).done(function(e){logger.info("Layouts Downloaded"),n=!0}).fail(function(e,t){logger.error("Layout Download Queue Failed"),n=!1}).always(function(){if(null!=t.defaultPlaylist){logger.info("Downloading Default Playlist");var e=new a;e.items.push(t.defaultPlaylist),Q(e).done(function(e){logger.debug("Default Playlist Downloaded"),n&=!0}).fail(function(e,t){logger.error("Default Playlist Download Failed"),n=!1}).always(function(){$("#userMessageText").empty(),n?i.resolve():i.reject()})}else i.resolve()})}else setTimeout(function(){i.resolve()},500);return i.promise()}(_.content).then(function(){return logger.info("All content downloaded."),_&&_.dataSyncServices&&_.content.integrations&&_.content.integrations.length>0?(logger.info("Restarting data sync services sync..."),v.synchroniseIntegrationsForMediaAssets(_.dataSyncServices,_.content.integrations,_.content.mediaAssets)):(logger.info("No last config or data sync services config object in configuration. Skipping DSS synchronisation..."),$.Deferred().resolve())}).then(function(){logger.info("Data Sync Services Synchronisation complete. Download Process Completed"),null==T&&null==T||T(_);try{logger.debug("Saving configuration to storage");var o=JSON.stringify(r);n.write(e.application.fileSystem.systemFiles.lastConfigFilePath,o).done(function(){O=$.grep(_.content.mediaAssets,function(e,t){return e.isExternallyDelivered}),i&&(logger.debug("Performing instant reboot due to zero touch configuration changes."),I.reboot(D.ZERO_TOUCH)),t.resolve()}).fail(function(e){logger.error("Error whilst saving configuration file: "+e.message),t.reject()})}catch(e){logger.error("Error whilst saving configuration file: "+e.message),t.reject()}}).fail(function(){logger.error("Download Process Failed"),t.reject()}).always(function(){N=!1})})}).fail(function(e,n,i){de(this.url,this.data,e.status,i,e.responseText),t.reject()}),t.promise()}function J(){var e=function(){var e=x;if(null!=_)if(_.connectivity.configurationIntervalScheme==r.REGULAR_INTERVAL)e=_.connectivity.configurationCheckInterval;else{var t=l.now().setTime(_.connectivity.configurationCheckTime);t<l.now()&&(t=t.addDays(1)),e=t.subtract(l.now())}return e}();setTimeout(z,e)}function Y(){var e=E;return null!=_&&(e=_.connectivity.healthCheckInterval),logger.debug("Health Check interval is : "+e),e}function Q(e){var t=$.Deferred();return function e(t,n){if(0!=t.items.length){var i=t.currentItem();logger.info("Playlist Download Start "+i.name),se(i.externalId);var o=new a;$(i.playlistMediaAssets).each(function(e,t){if(t.mediaAsset.contentType==s.FEED)$(t.feed.feedMediaAssets).each(function(e,t){var n=$.grep(o.items,function(e,n){return e.externalId==t.mediaAssetId}).length;0==n&&o.push(t.mediaAsset)});else{var n=$.grep(o.items,function(e,n){return e.externalId==t.mediaAssetId}).length;0==n&&o.push(t.mediaAsset)}}),logger.debug("Items in queue: "+o.items.length),X(o,!0).done(function(e){var n=t.items.shift();t.processedItems.push(n),logger.info("Playlist Download Complete "+n.name),le(n.externalId)}).fail(function(e,n){var i=t.items.shift();t.failedItems.push(i),logger.error("Playlist Download Fail "+i.name+" "+n.length+" assets have failed to download"),ce(i.externalId)}).always(function(){setTimeout(function(){e(t,n)},500)})}else 0==t.failedItems.length?n.resolve(t.processedItems):n.reject(t.processedItems,t.failedItems)}(e,t),t.promise()}function X(e,t){var n=$.Deferred();return Z(e,n,t),n.promise()}function Z(e,t,n){0!=e.items.length?re()?q().done(function(i){i?B(e,t,n):t.reject(e.processedItems,e.failedItems)}):B(e,t,n):0==e.failedItems.length?t.resolve(e.processedItems):t.reject(e.processedItems,e.failedItems)}function B(t,o,a){var r=t.currentItem();if(logger.info("Checking if asset requires a download"),0==function(t){var i=!1;try{var o=t.isDownloadable;if(o)if(t.isExternallyDelivered)i=!0;else{var a="";""!==e.application.fileSystem.root&&(a=a+e.application.fileSystem.root+"/"),""!==e.application.fileSystem.mediaDirectory&&(a=a+e.application.fileSystem.mediaDirectory+"/"),a+=t.localFileName,0==n.exists(a)&&(i=!0)}}catch(e){logger.error("Error while checking if a download is required "+e.message)}return i}(r))return r=t.items.shift(),t.processedItems.push(r),void setTimeout(function(){Z(t,o,a)},500);logger.info("Media Asset Download Start "+r.name),a&&se(r.externalId),require(["system/plugins/DownloadPlugin"],function(l){var c=new l,u="";0===r.remoteUrl.lastIndexOf(e.application.api.url,0)&&(u="?sl_app_id="+e.application.api.appId+"&sl_app_key="+e.application.api.appKey+"&sl_client_id="+e.application.api.clientId+"&sl_client_key="+e.application.api.clientKey+"&sl_auth_token="+encodeURIComponent(e.application.api.authToken),"Signagelive"!==e.application.api.brand&&(u+="&sl_install_id="+e.application.api.brand));var d=r.remoteUrl+u,g="";""!==e.application.fileSystem.root&&(g=g+e.application.fileSystem.root+"/"),""!==e.application.fileSystem.mediaDirectory&&(g=g+e.application.fileSystem.mediaDirectory+"/"),g+=r.localFileName,logger.debug("Local file name: "+g),c.downloadFile(d,g,r.contentType).done(function(l,c){if(r.contentType==s.RSS)f.loadRssAssetIntoCache(r),W(t,a).then(function(){Z(t,o,a)});else if(r.contentType==s.WIDGET){logger.info("Unzipping widget: "+r.localFileName);var u="";""!==e.application.fileSystem.root&&(u=u+e.application.fileSystem.root+"/"),""!==e.application.fileSystem.widgetDirectory&&(u=u+e.application.fileSystem.widgetDirectory+"/"),u+=r.localFileName.replace(".wgt",""),logger.debug("Creating new widget directory: "+u),i.createDirectory(u).done(function(){logger.debug("New Directory created. Unzipping "+c+" to destination "+u),n.unzip(c,u).done(function(){logger.debug("Successfully extracted widget file: "+c),W(t,a).then(function(){Z(t,o,a)})}).fail(function(){logger.error("Failed to upzip widget pckage"),ee(c,t,a).then(function(){Z(t,o,a)})})}).fail(function(){ee(c,t,a).then(function(){Z(t,o,a)})})}else W(t,a).then(function(){Z(t,o,a)})}).fail(function(e,n){ee(n,t,a).then(function(){Z(t,o,a)})})})}function W(e,t){var n=$.Deferred(),i=e.items.shift();return e.processedItems.push(i),logger.info("Media Asset Download Complete "+i.name),t?(g.sendMediaAssetDownloaded(i),le(i.externalId).always(function(){setTimeout(function(){n.resolve()},500)})):setTimeout(function(){n.resolve()},500),n}function ee(e,t,i){var o=$.Deferred(),a=t.items.shift();return t.failedItems.push(a),logger.error("Media Asset Download Fail "+a.name),i?ce(a.externalId).always(function(){try{n.delete(e).always(function(){setTimeout(function(){o.resolve()},500)})}catch(e){logger.error("Error whilst removing a failed download file "+e.message),setTimeout(function(){o.resolve()},500)}}):setTimeout(function(){o.resolve()},500),o}function te(){logger.info("HEALTH CHECK"),re()?q().done(function(e){e?ne():j=setTimeout(te,Y())}):ne()}function ne(){ae("notifications",{type:"POST",data:{type:"HealthCheck"}}).done(function(e,t,n){P.lastConnectionTime=new Date,logger.info("Health Check Code "+n.status)}).fail(function(t,n,i){de(this.url,this.data,t.status,i,t.responseText),401==t.status&&(e.application.api.authTokenExpiry=null)}).always(function(){j=setTimeout(te,Y())})}function ie(e){var t=$.Deferred();return logger.info("Notify "+e.type+", Object Id: "+e.object_id),re()?q().done(function(n){n?oe(e).done(function(){t.resolve()}).fail(function(){t.reject()}):t.reject()}):oe(e).done(function(){t.resolve()}).fail(function(){t.reject()}),t}function oe(t){var n=$.Deferred();return ae("notifications",{type:"POST",data:t}).done(function(e,t,i){P.lastConnectionTime=new Date,logger.info("Notify Response Code "+i.status),n.resolve()}).fail(function(t,i,o){401==t.status&&(e.application.api.authTokenExpiry=null),de(this.url,this.data,t.status,o,t.responseText),n.reject()}),n}function ae(e,t){return U.executeAPICall(y.PLAYER_API,e,t)}function re(){return logger.debug("isAuthenticationRequired()"),null==e.application.api.authTokenExpiry||e.application.api.authTokenExpiry<l.now()}function se(e){return ie({type:"DownloadStart",object_id:e})}function le(e){return ie({type:"DownloadComplete",object_id:e})}function ce(e){return ie({type:"DownloadFail",object_id:e})}function ue(){try{if(logger.info("Sending system report"),re()&&0==q())return void fe(!0);var e=new c;e.generate().done(function(){var t=JSON.stringify(e);logger.debug(t),ae("systemreport",{type:"POST",data:e}).done(function(e,t,n){P.lastConnectionTime=new Date,logger.info("System Report Done "+n.status),fe(!1)}).fail(function(e,t,n){de(this.url,this.data,e.status,n,e.responseText),fe(!0)})}).fail(function(){logger.debug("System Report Generation Failed"),fe(!0)})}catch(e){logger.debug("System Report Generation Failed "+e.message),fe(!0)}}function fe(e){var t=function(e){var t=F;if(!0===e)return 6e4;if(null!=_)if(_.connectivity.diagnosticsUpdateIntervalScheme==r.REGULAR_INTERVAL)t=_.connectivity.diagnosticsUpdateInterval;else{var n=l.now().setTime(_.connectivity.diagnosticsUpdateTime);n<l.now()&&(n=n.addDays(1)),t=n.subtract(l.now())}return t}(e);logger.info("Next System Report to be sent in "+t/1e3+" seconds"),setTimeout(ue,t)}function de(e,t,n,i,o){var a={url:e,requestData:t,responseStatus:n,responseMessage:i,responseBody:o};logger.error("API Error "+JSON.stringify(a))}P.healthCheck=function(){return te()},P.initialize=function(t,n){var i;logger.info("Initializing SLAPIInterface"),S=n.deviceRegistered,A=n.deviceAlreadyRegistered,T=n.configuration,C=n.configurationNoChange,h.registerAPIInterface(P),void 0===e.application.api.clientKey||null===e.application.api.clientKey||""===e.application.api.clientKey?H():(null!=t&&(_=t,L=t.lastModified,O=$.grep(_.content.mediaAssets,function(e,t){return e.isExternallyDelivered})),(i=$.Deferred(),ie({type:"SystemStart"}).done(function(){i.resolve()}).fail(function(){i.reject()}),i).always(function(){_&&_.dataSyncServices&&_.content.integrations&&_.content.integrations.length>0?v.synchroniseIntegrationsForMediaAssets(_.dataSyncServices,_.content.integrations,_.content.mediaAssets).always(function(){z(),j=setTimeout(te,Y()),ue()}):(z(),j=setTimeout(te,Y()),ue())}))},P.notifyFirmwareUpdateComplete=function(){ie({type:"FirmwareUpdateComplete"})},P.notifyFirmwareUpdateFail=function(){ie({type:"FirmwareUpdateFailed"})}}});