define(["properties/App.Settings","properties/App.Properties","system/io/File","system/io/Directory","system/io/DirectoryInfo","system/network/NetworkInterface","system/power/PowerInterface","system/DateTime","models/ConfigurationModel","core/SLAPIInterface","controllers/UserMessageController","gui/views/MediaPlayerView","controllers/ApplicationUpdateController","controllers/FirmwareUpdateController","controllers/UserConfigurationController","system/remotecontrol/RemoteControlInterface","models/KeyboardShortcutsModel","controllers/InterruptController","models/PlaybackStartEndReasons","controllers/ScreenCaptureController","controllers/WebBasedInterruptsController","controllers/TouchScreenController","system/clock/ClockInterface","system/sound/SoundInterface","controllers/RealTimeEventsController","controllers/LocalAPIController","system/graphics/GraphicsInterface","models/RebootReasons","core/LogUploadInterface"],function(e,t,n,o,i,a,r,l,s,c,u,d,g,m,f,p,h,y,v,k,C,E,S,w,T,b,P,I,B){return function(t){var a=this,M=null,D=null,F=null,O=new d({showSetup:le}),R=null,N=null,W=!1,U=null,x=null,_=null,K=!1,A=!1;function L(){setTimeout(function(){ae()},3e4)}function H(){ue();var t=1e4;n.exists(e.application.fileSystem.systemFiles.lastConfigFilePath)?(logger.debug("Loading last configuration"),u.postMessage("Loading saved configuration"),n.read(e.application.fileSystem.systemFiles.lastConfigFilePath).done(function(n){try{D=new s(JSON.parse(n)),(o=$.Deferred(),e.application.features.deleteOldFilesOnStartup?(logger.debug("Removing old files..."),re(!0).done(function(){o.resolve()}).fail(function(){logger.error("Error removing old files."),o.reject()})):setTimeout(function(){logger.debug("Player not configured to clear storage on startup"),o.resolve()},50),o).always(function(){e.application.features.canPlayInterrupts?y.initialize(O,D.content.interrupts,D.screenControl).always(function(){e.application.features.canSwitchScreenOnOff?te():me()}):e.application.features.canSwitchScreenOnOff?te():me(),z(!1),de(),X(),V(t),T.updateConfiguration(D),Y()})}catch(e){logger.error("An error occurred loading configuration data at startup "+e.message+". Starting the API interface..."),u.postMessage("Unable to load saved configuration. Connecting to Signagelive..."),V(t=0)}var o}).fail(function(){logger.error("An error occurred reading the stored configuration data at startup. Starting the API interface..."),u.postMessage("Unable to load saved configuration. Connecting to Signagelive..."),V(t=0)})):(logger.debug("No configuration to load"),V(t=0)),e.application.features.canPerformApplicationUpdates&&(new g).start(),e.application.features.canPerformFirmwareUpdates&&(R=new m).start(),e.application.features.canTakeScreenshots&&null==N&&(N=new k),e.application.features.canListenForWebBasedInterrupts&&J()}function V(t){M=new c,setTimeout(function(){M.initialize(D,{deviceRegistered:Z,deviceAlreadyRegistered:q,configuration:G,configurationNoChange:j})},t),null!=D&&null!=D.proofOfPlayConfig&&proofOfPlayLogger.init(D.proofOfPlayConfig,e.application.api)}function z(e){B.init(D.logging,D.clientDetails).then(function(){e&&D.logging.application&&D.logging.application.upload&&B.uploadLogs()})}function Y(){null==x&&((x=new b(D)).initialize(),x.onEvent=function(e,t){switch(e){case"SoftTrigger":O.softTrigger(t)}})}function Z(t){logger.debug("Registration Callback "+t);var o=JSON.stringify({clientKey:t});n.write(e.application.fileSystem.systemFiles.clientKeyFilePath,o),e.application.api.clientKey=t}function q(){u.postMessage("This player has been previously connected to Signagelive, please deactivate it to continue with re-activation.\nID: "+e.application.api.clientId)}function j(){logger.info("Configuration checked - no update"),Q(),e.application.features.canListenForWebBasedInterrupts&&(J(),C.isRunning()&&C.checkForConfigurationUpdate())}function G(t){logger.info("Configuration checked - updating configuration");var n,o=!1,i=f.modules().display;if(i&&(!0===i.multiMonitorModeEnabled||!0===i.windowModeEnabled)){var a=D?D.clientDetails.maxNumberOfOutputs:2;logger.info("Current max outputs: "+a),logger.info("Updated max outputs: "+t.clientDetails.maxNumberOfOutputs),a!==t.clientDetails.maxNumberOfOutputs&&(logger.info("Max number of outputs has changed. Restart required."),o=!0)}F=D,D=t,e.application.features.canPlayInterrupts?y.initialize(O,D.content.interrupts,D.screenControl).always(function(){e.application.features.canSwitchScreenOnOff?te():me()}):e.application.features.canSwitchScreenOnOff?te():me(),z(!0),de(),X(),setTimeout(function(){re(e.application.features.deleteOldFilesOnContentUpdate)},15e3),D.logging.screencapture.screenshotAtNextContentCheck&&null!=N&&setTimeout(function(){logger.info("Taking on demand screenshot"),N.takeOnDemandScreenshot()},2e4),D.connectivity.instantReboot?(logger.debug("Performing instant reboot in 30 seconds."),setTimeout(function(){r.reboot(I.INSTANT_REBOOT)},3e4)):Q(),null!=D.proofOfPlayConfig?(logger.debug("Config Update: Updating Proof of Play config"),proofOfPlayLogger.updateConfig(D.proofOfPlayConfig,e.application.api)):logger.debug("Config Update: Proof of Play Configuration is null"),null!=D.firmwareUpdate&&(n=D.firmwareUpdate,R.isFirmwareUpdateRequired(n)?R.updateFirmware(n):R.cancelUpdate()),e.application.features.canListenForWebBasedInterrupts&&(J(),C.isRunning()&&C.checkForConfigurationUpdate()),o&&(logger.info("Max Number of outputs has changed. Restarting application in 30 seconds..."),setTimeout(function(){r.restartApplication()},3e4)),T.updateConfiguration(D),null==x&&Y(),x.updateConfiguration(D),function(e){if(e.remoteSettings){var t=e.remoteSettings;t.nativePortraitRotation&&(logger.info("Native Protrait Rotation included in Remote Settings."),P.hasNativePortraitModeSettingChanged(t.nativePortraitRotation).done(function(e){e&&(logger.info("Native Protrait Rotation setting has changed... Applying setting..."),setTimeout(function(){fe(v.REMOTE_SETTINGS_UPDATE),P.setNativePortraitMode(t.nativePortraitRotation).done(function(e){logger.info("Native Portrait Settings Updated: "+e),O.adjustLayoutViewDimensions(document.documentElement.clientWidth,document.documentElement.clientHeight),me()})},5e3))}))}}(D)}function J(){if(0==C.isRunning()){logger.info("Interrupts available - start web based interrupts controller");var t={url:e.application.webBasedInterrupts.url,configurationCheckInterval:e.application.webBasedInterrupts.configurationCheckInterval,serialNo:D?D.clientDetails.signageliveSerialNumber:null,switchScreenOn:ne,switchScreenOff:oe};C.initialize(t).done(function(){logger.info("Web Triggers inialized")}).fail(function(){logger.error("Error: Failed to initialize web based interrupts controller")})}else logger.info("Web based interrupts controller is already running")}function Q(){null!=N&&setTimeout(function(){N.uploadAllScreenshots()},3e4)}function X(){logger.info("Setting up scheduled screenshots"),e.application.features.canTakeScreenshots&&(null==N&&(N=new k),setTimeout(function(){logger.info("Stopping and starting screenshots");try{N.stop(),N.initialize(D),N.start()}catch(e){logger.error("Error configuring screenshots: "+e.message)}},5e3))}a.propertiesViewVisible=!1,a.setupViewVisible=!1,a.initialize=function(){logger.info("Initializing SLClientEngine"),(new E).initialize({showDeviceProperties:se,showSetupScreen:le}),e.application.features.canListenForRemoteKeyPresses&&($("#remoteFocus").focus(),p.initialize(),$("#remoteFocus").keydown(function(e){var t=e.keyCode;logger.info("KEY PRESSED: "+t);var n="";switch(t){case p.keys.KEY_UP:n="UP";break;case p.keys.KEY_DOWN:n="DOWN";break;case p.keys.KEY_LEFT:n="LEFT";break;case p.keys.KEY_RIGHT:n="RIGHT";break;case p.keys.KEY_RW:logger.info("RW key pressed"),O.back();break;case p.keys.KEY_FF:logger.info("FF key pressed"),O.skip();break;case p.keys.KEY_PLAY:logger.info("PLAY key pressed"),O.play();break;case p.keys.KEY_PAUSE:logger.info("PAUSE key pressed"),n="PAUSE";break;case p.keys.KEY_MUTE:logger.info("MUTE key pressed"),f.toggleMute(),f.saveSettings();break;case p.keys.KEY_VOL_UP:logger.info("VOL_UP key pressed"),f.volumeUp();try{w.getVolume().done(function(e){e++,w.setVolume(e)})}catch(e){logger.error(e)}break;case p.keys.KEY_VOL_DOWN:logger.info("VOL_DOWN key pressed"),f.volumeDown();try{w.getVolume().done(function(e){e--,w.setVolume(e)})}catch(e){logger.error(e)}break;case p.keys.KEY_INFO:logger.info("INFO key pressed"),a.propertiesViewVisible||se();break;case p.keys.KEY_SETUP:logger.info("SETUP key pressed"),a.setupViewVisible||le();break;case p.keys.KEY_ENTER:logger.info("ENTER key pressed"),n="ENTER";break;case p.keys.KEY_0:case p.keys.KEY_1:case p.keys.KEY_2:case p.keys.KEY_3:case p.keys.KEY_4:case p.keys.KEY_5:case p.keys.KEY_6:case p.keys.KEY_7:case p.keys.KEY_8:case p.keys.KEY_9:if(logger.info("Remote key pressed: "+t),p.keyCodesToInterruptKeys){var o=p.keyCodesToInterruptKeys[t];null!=o&&(logger.info("Attempting to trigegr interrupt for key: "+o),y.triggerInterrupt(o,"KeyboardEvent",!1,!0).fail(function(){O.onKeyPress(o)}))}break;case p.keys.KEY_POWER:K?oe(!0):ne(!0);default:logger.info("Key pressed: "+t)}""!=n&&O.onKeyPress(n)})),f.initialize().done(function(){0==n.exists(e.application.fileSystem.systemFiles.settingsFilePath)?(logger.info("Settings file: "+e.application.fileSystem.systemFiles.settingsFilePath+" does not exist!"),logger.debug("First boot Handled Called"),W=!0,require(["gui/views/SetupView"],function(e){var t=new e({complete:function(e){$("#"+t.id).remove(),ce(e)}},!1,!0);$("#canvas").append(t.html),t.addedToCanvas()})):e.user.settingsLoaded?($.extend(!0,e.application.modules,f.modules()),e.application.features.canSyncDateTime?function(t){try{e.application.features.canSyncDateTime?(u.postMessage("Checking the date time is correct"),logger.info("Checking the date time is correct"),$.ajax({url:e.application.dateTimeServer+t.timeZone.id,contentType:"application/json",timeout:1e4,cache:!1}).done(function(e,t,n){logger.info("Local Time for "+e.time_zone+" is "+e.local_time);var o=l.now().addMinutes(2),i=l.now().addMinutes(-2),a=l.parse(e.local_time);a>i&a<o?(L(),H()):(logger.debug("Resyncing date time on the panel"),u.postMessage("Resetting the date time, your panel may automatically restart in a moment"),l.setDateTime(l.parse(e.local_time)).done(function(){logger.debug("Date time successfully updated."),L(),H()}).fail(function(){logger.error("There was an error updating the date time on the panel. Retrying in 30 seconds..."),L()}))}).fail(function(e,t,n){logger.error("There was an error updating the date time on the panel. Retrying in 30 seconds..."),l.now()<=l.parse("2013-10-01T00:00:00")?(u.postMessage("The date time is incorrect, please re-connect this panel to the internet to automatically re-sync the date time"),ae()):(H(),L())})):(logger.warning("Cannot sync date time for this player type. Starting Core services..."),H(),L())}catch(e){logger.error("Date time could not be checked"),H(),L()}}(e.user.mySettings):H()):logger.error("Settings have not loaded"),(new h).setup({showSetup:le,showInfo:se,triggerKeyboardInterrupt:ge})}).fail(function(){logger.error("SLClientEngine: Failed to initialize User Configuration Controller.")})},a.firstBootSequenceComplete=function(){H()};var ee=0;function te(){clearTimeout(ee),ie().then(function(e){D.screenControl.isScreenCurrentlyScheduledOn(e)?ne(D.screenControl.persistedState):(oe(D.screenControl.persistedState),$("#userMessage").empty()),null!=D.screenControl.nextAction()&&function e(){var t=D.screenControl.nextAction();if(null!=t){var n=t.time.subtract(l.now());ee="on"==t.action?setTimeout(function(){ne(),e()},n):setTimeout(function(){oe(),e()},n)}}()})}function ne(e){logger.info("Switching screen on"),e&&(_="ScreenOn"),r.switchScreenOn(e).done(function(){$("#userMessageText").empty(),me()})}function oe(e){logger.info("Switching screen off"),e&&(_="ScreenOff"),fe(v.SCREEN_OFF),r.switchScreenOff(e).done(function(){$("#userMessageText").empty()})}function ie(){var e=$.Deferred();return r.readLastScreenStatus().then(function(t){_=t?t.screenStatus:null,e.resolve(t)}),e}function ae(){try{logger.info("Checking date time is correct"),n.read(e.application.fileSystem.systemFiles.settingsFilePath).done(function(t){var n=JSON.parse(t);logger.info("URL for checking time is: "+e.application.dateTimeServer+n.timeZone.id),$.ajax({url:e.application.dateTimeServer+n.timeZone.id,contentType:"application/json",timeout:1e4,cache:!1}).done(function(t,n,o){logger.info("Local Time for "+t.time_zone+" is "+t.local_time);var i=l.now().addMinutes(2),a=l.now().addMinutes(-2),r=l.parse(t.local_time);r>a&r<i?(logger.info("DateTime is correct"),setTimeout(function(){ae()},1e3*e.application.features.syncDateTimeFrequency)):(logger.info("DateTime is incorrect... resetting it..."),l.setDateTime(l.parse(t.local_time)).done(function(){logger.info("Date time successfully updated."),setTimeout(function(){ae()},1e3*e.application.features.syncDateTimeFrequency)}).fail(function(){logger.error("There was an error updating the date time on the panel."),setTimeout(function(){ae()},3e4)}))}).fail(function(){logger.error("Error calling out to timezone server while checking datetime"),setTimeout(function(){ae()},3e4)})}).fail(function(e){logger.error("Error reading settings file whilst checking datetime"),setTimeout(function(){ae()},3e4)})}catch(e){logger.error("Unexpected error checking datetime: "+e),setTimeout(function(){ae()},3e4)}}function re(t){var n=$.Deferred();try{if(null==D||0==e.application.features.canDownloadFiles)return;logger.info("Checking directory: "+e.application.fileSystem.root+"/"+e.application.fileSystem.mediaDirectory);var a="";""!==e.application.fileSystem.root&&(a=a+e.application.fileSystem.root+"/"),""!==e.application.fileSystem.mediaDirectory&&(a+=e.application.fileSystem.mediaDirectory);var r=new i(a);r.initialize().done(function(){logger.info("There are "+r.files.length+" files in the media directory");var i=0,a=[];$(r.files).each(function(e,t){if("folder"!=t.type&&(logger.info("Checking if "+t.name+" is required"),1!=$.grep(D.content.mediaAssets,function(e,n){return e.localFileName===t.name}).length)){var n=null;if(null!=F){var o=$.grep(F.content.mediaAssets,function(e,n){return e.localFileName===t.name});o.length>0&&(n=o[0])}a.push({mediaAsset:n,file:t}),i++}}),logger.info("There are "+i+" to delete");var l=$.Deferred().resolve();a.forEach(function(n){l=l.then(function(){return function(t,n){var i=$.Deferred(),a=t.file;try{if(!1===n)return null!=t.mediaAsset&&(logger.info("Media asset: "+a.name+" removed from config but not player. File will be removed on next reboot"),T.sendMediaAssetRemoved(t.mediaAsset)),$.Deferred().resolve();-1!=a.path.indexOf(".wgt")?(logger.info("Widget File "+a.name+" is to be deleted."),0===a.name.lastIndexOf("gaplessPlaylist_",0)?(logger.debug("Not deleting: "+a.name+" as this is a gapless playlist file."),i.resolve()):a.delete().always(function(n){n?(logger.info(a.name+" deleted."),null!=t.mediaAsset&&T.sendMediaAssetRemoved(t.mediaAsset)):logger.warning("Warning: "+a.name+" was not deleted. It may have already been deleted."),logger.info("Deleting widget directory and files...");var r=a.path.lastIndexOf("/")+1,l=a.path.substr(r).replace(".wgt",""),s="";""!==e.application.fileSystem.root&&(s=s+e.application.fileSystem.root+"/"),""!==e.application.fileSystem.widgetDirectory&&(s=s+e.application.fileSystem.widgetDirectory+"/"),s+=l,logger.info("Deleting widget directory and files: "+s),o.deleteDirectory(s).done(function(){logger.info("Widget directory deleted")}).fail(function(e){logger.info("An error occurred when trying to delete the widget directory: "+e)}).always(function(){i.resolve()})})):0===a.name.lastIndexOf("gaplessPlaylist_",0)?(logger.debug("Not deleting: "+a.name+" as this is a gapless playlist file."),i.resolve()):(logger.info("File "+a.name+" is to be deleted."),a.delete().always(function(e){e?(logger.info(a.name+" deleted."),null!=t.mediaAsset&&T.sendMediaAssetRemoved(t.mediaAsset)):logger.warning("Warning: "+a.name+" not deleted."),i.resolve()}))}catch(e){logger.error("Error deleting "+a.name+" error: "+e.message),i.resolve()}return i.promise()}(n,t)})}),l.done(function(){logger.info("Media files that are no longer required have been removed."),n.resolve()})}).fail(function(){logger.error("Error loading directory information for "+a),n.resolve()})}catch(e){logger.error("Error whilst removing files that are not required from the media directory: "+e.message),n.reject()}return n}function le(){a.setupViewVisible||D.screenControl.isScreenCurrentlyScheduledOff()&&"ScreenOn"!==_||"ScreenOff"==_||!K||require(["gui/views/SetupView"],function(e){fe(v.SETUP_SCREEN);var t=new e({complete:function(e){$("#"+t.id).remove(),a.setupViewVisible=!1,ce(e)},cancel:function(){$("#"+t.id).remove(),a.setupViewVisible=!1,ie().then(function(e){(!e||e&&"ScreenOff"!==e.screenStatus)&&me()})}},!0,D.remoteSettings);a.setupViewVisible=!0,$("#canvas").append(t.html),t.addedToCanvas()})}function se(){a.propertiesViewVisible||D.screenControl.isScreenCurrentlyScheduledOff()&&"ScreenOn"!==_||"ScreenOff"==_||!K||require(["gui/views/DevicePropertiesView"],function(t){var n=new t;n.initialize().done(function(){"86BH5C"===e.application.model&&fe(v.SETUP_SCREEN),a.propertiesViewVisible=!0,$("#canvas").append(n.html),setTimeout(function(){a.propertiesViewVisible=!1,$("#"+n.id).remove(),"86BH5C"===e.application.model&&me()},15e3)})})}function ce(t){logger.info("Settings complete "+JSON.stringify(t));try{t.layoutFit&&t.layoutFit.id!=f.layoutFit().id&&f.layoutFit(t.layoutFit),function(e){var t=$.Deferred();if(e.usePMModeForScreenManagement!=f.usePMModeForScreenManagement())if(e.usePMModeForScreenManagement)try{r.getPMMode().then(function(e){"screenOffAlways"!==e?r.setPMMode().then(function(){logger.info("PM Mode set to screenOffAlways"),t.resolve()}):t.resolve()}),f.usePMModeForScreenManagement(e.usePMModeForScreenManagement)}catch(n){logger.warning("Issue getting/setting PM Mode - reverting change"),e.usePMModeForScreenManagement=f.usePMModeForScreenManagement(),t.resolve()}else f.usePMModeForScreenManagement(e.usePMModeForScreenManagement),t.resolve();else t.resolve();return t}(t).then(function(){t.rotation.angle!=f.rotation().angle&&(f.rotation(t.rotation),W||t.timeZone.id!=f.timeZone().id||ue()),f.modules(t.modules),void 0!==t.rotateVideos&&f.rotateVideos(t.rotateVideos),e.application.features.canPerformFirmwareUpdates&&(f.remoteFirmwareUpdates(t.remoteFirmwareUpdates),1!=t.remoteFirmwareUpdates.enabled||null!=R&&0!=R.started||(R=new m).start(),0==t.remoteFirmwareUpdates.enabled&&null!=R&&!0===R.started&&R.stop());var n=!1;void 0!==t.useNTP&&t.useNTP!=f.useNTP()&&(f.useNTP(t.useNTP),n=!0);var o=!1;t.timeZone.id!=f.timeZone().id&&(f.timeZone(t.timeZone),o=!0),t.modules.interactiveKiosk&&t.modules.interactiveKiosk.supported&&(t.modules.interactiveKiosk.enabled!=f.interactiveKiosk().enabled||t.modules.interactiveKiosk.idleIntervalInSeconds!=f.interactiveKiosk().idleIntervalInSeconds)&&f.interactiveKiosk(t.modules.interactiveKiosk),f.saveSettings().always(function(){W||n||o?(logger.info("Either first boot, NTP settings updated or Timezone settings updated. Setting Timezone and Time as appropriate..."),function(t){logger.info("Resyncing DateTime...");var n=$.Deferred();return!0===e.application.features.canSyncDateTime?($.ajax({url:e.application.dateTimeServer+t.timeZone.id,contentType:"application/json"}).done(function(e){logger.info("Local Time for "+e.time_zone+" is "+e.local_time),l.setDateTime(l.parse(e.local_time),t.useNTP).done(function(){logger.info("Date time successfully updated."),n.resolve(!0)}).fail(function(){logger.error("There was an error updating the date time on the panel."),n.resolve(!1)})}).fail(function(){logger.error("Failed to retrieve remote date time"),n.resolve(!1)}),n):n.resolve(!1)}(t).always(function(o){(function(t){logger.info("Updating timezone...");var n=$.Deferred(),o=!1;return!0===e.application.features.canSetTimeZone&&!0===t.useNTP?(S.setTimeZone(t.timeZone.id,t.timeZone).done(function(){logger.info("Timezone updated to "+t.timeZone.id),o=!0}).fail(function(){logger.error("Error updating the timezone")}).always(function(){n.resolve(o)}),n):n.resolve(!1)})(t).always(function(e){logger.info("timezoneUpdated: "+e+", NTP Updated: Time updated: "+o+"Use NTP: "+t.useNTP),!0===e||!0===n||!0===o&&!0===t.useNTP?(logger.info("Restart Required. Rebooting in 5 seconds..."),u.postMessage("Settings applied. Restarting device..."),setTimeout(function(){r.reboot(I.TIMEZONE_UPDATE)},3e3)):ie().then(function(e){(!e||e&&"ScreenOff"!==e.screenStatus)&&(W?(W=!1,a.firstBootSequenceComplete()):me())})})})):ie().then(function(e){(!e||e&&"ScreenOff"!==e.screenStatus)&&me()})})})}catch(e){logger.error("Error whilst saving settings : "+e.message),me()}}function ue(){if(f.isRotated())switch(f.rotationAngle()){case 90:$("#canvas").width(document.documentElement.clientHeight),$("#canvas").height(document.documentElement.clientWidth),$("#canvas").css("left",(document.documentElement.clientWidth-document.documentElement.clientHeight)/2+"px"),$("#canvas").css("top",(document.documentElement.clientHeight-document.documentElement.clientWidth)/2+"px"),$("#canvas").removeClass("rotate180"),$("#canvas").removeClass("rotate270"),$("#canvas").addClass("rotate90"),$("#layoutBackgroundCanvas").attr("width",document.documentElement.clientHeight),$("#layoutBackgroundCanvas").attr("height",document.documentElement.clientWidth),$("#layoutBackgroundCanvas").width(document.documentElement.clientHeight),$("#layoutBackgroundCanvas").height(document.documentElement.clientWidth),$("#layoutBackgroundCanvas").css("left",(document.documentElement.clientWidth-document.documentElement.clientHeight)/2+"px"),$("#layoutBackgroundCanvas").css("top",(document.documentElement.clientHeight-document.documentElement.clientWidth)/2+"px"),$("#layoutBackgroundCanvas").removeClass("rotate180"),$("#layoutBackgroundCanvas").removeClass("rotate270"),$("#layoutBackgroundCanvas").addClass("rotate90"),$("#layoutBackgroundImage").attr("width",document.documentElement.clientHeight),$("#layoutBackgroundImage").attr("height",document.documentElement.clientWidth),$("#layoutBackgroundImage").width(document.documentElement.clientHeight),$("#layoutBackgroundImage").height(document.documentElement.clientWidth),$("#layoutBackgroundImage").css("left",(document.documentElement.clientWidth-document.documentElement.clientHeight)/2+"px"),$("#layoutBackgroundImage").css("top",(document.documentElement.clientHeight-document.documentElement.clientWidth)/2+"px"),$("#layoutBackgroundImage").removeClass("rotate180"),$("#layoutBackgroundImage").removeClass("rotate270"),$("#layoutBackgroundImage").addClass("rotate90"),O.adjustLayoutViewDimensions(document.documentElement.clientHeight,document.documentElement.clientWidth);break;case 180:$("#canvas").css("left","0px"),$("#canvas").css("top","0px"),$("#canvas").width(document.documentElement.clientWidth),$("#canvas").height(document.documentElement.clientHeight),$("#canvas").removeClass("rotate90"),$("#canvas").removeClass("rotate270"),$("#canvas").addClass("rotate180"),$("#layoutBackgroundCanvas").css("left","0px"),$("#layoutBackgroundCanvas").css("top","0px"),$("#layoutBackgroundCanvas").attr("width",document.documentElement.clientWidth),$("#layoutBackgroundCanvas").attr("height",document.documentElement.clientHeight),$("#layoutBackgroundCanvas").width(document.documentElement.clientWidth),$("#layoutBackgroundCanvas").height(document.documentElement.clientHeight),$("#layoutBackgroundCanvas").removeClass("rotate90"),$("#layoutBackgroundCanvas").removeClass("rotate270"),$("#layoutBackgroundCanvas").addClass("rotate180"),$("#layoutBackgroundImage").css("left","0px"),$("#layoutBackgroundImage").css("top","0px"),$("#layoutBackgroundImage").attr("width",document.documentElement.clientWidth),$("#layoutBackgroundImage").attr("height",document.documentElement.clientHeight),$("#layoutBackgroundImage").width(document.documentElement.clientWidth),$("#layoutBackgroundImage").height(document.documentElement.clientHeight),$("#layoutBackgroundImage").removeClass("rotate90"),$("#layoutBackgroundImage").removeClass("rotate270"),$("#layoutBackgroundImage").addClass("rotate180"),O.adjustLayoutViewDimensions(document.documentElement.clientWidth,document.documentElement.clientHeight);break;case 270:$("#canvas").width(document.documentElement.clientHeight),$("#canvas").height(document.documentElement.clientWidth),$("#canvas").css("left",(document.documentElement.clientWidth-document.documentElement.clientHeight)/2+"px"),$("#canvas").css("top",(document.documentElement.clientHeight-document.documentElement.clientWidth)/2+"px"),$("#canvas").removeClass("rotate90"),$("#canvas").removeClass("rotate180"),$("#canvas").addClass("rotate270"),$("#layoutBackgroundCanvas").attr("width",document.documentElement.clientHeight),$("#layoutBackgroundCanvas").attr("height",document.documentElement.clientWidth),$("#layoutBackgroundCanvas").width(document.documentElement.clientHeight),$("#layoutBackgroundCanvas").height(document.documentElement.clientWidth),$("#layoutBackgroundCanvas").css("left",(document.documentElement.clientWidth-document.documentElement.clientHeight)/2+"px"),$("#layoutBackgroundCanvas").css("top",(document.documentElement.clientHeight-document.documentElement.clientWidth)/2+"px"),$("#layoutBackgroundCanvas").removeClass("rotate90"),$("#layoutBackgroundCanvas").removeClass("rotate180"),$("#layoutBackgroundCanvas").addClass("rotate270"),$("#layoutBackgroundImage").attr("width",document.documentElement.clientHeight),$("#layoutBackgroundImage").attr("height",document.documentElement.clientWidth),$("#layoutBackgroundImage").width(document.documentElement.clientHeight),$("#layoutBackgroundImage").height(document.documentElement.clientWidth),$("#layoutBackgroundImage").css("left",(document.documentElement.clientWidth-document.documentElement.clientHeight)/2+"px"),$("#layoutBackgroundImage").css("top",(document.documentElement.clientHeight-document.documentElement.clientWidth)/2+"px"),$("#layoutBackgroundImage").removeClass("rotate90"),$("#layoutBackgroundImage").removeClass("rotate180"),$("#layoutBackgroundImage").addClass("rotate270"),O.adjustLayoutViewDimensions(document.documentElement.clientHeight,document.documentElement.clientWidth)}else $("#canvas").removeClass("rotate90"),$("#canvas").removeClass("rotate180"),$("#canvas").removeClass("rotate270"),$("#canvas").css("left","0px"),$("#canvas").css("top","0px"),$("#canvas").width(document.documentElement.clientWidth),$("#canvas").height(document.documentElement.clientHeight),$("#layoutBackgroundCanvas").removeClass("rotate90"),$("#layoutBackgroundCanvas").removeClass("rotate180"),$("#layoutBackgroundCanvas").removeClass("rotate270"),$("#layoutBackgroundCanvas").css("left","0px"),$("#layoutBackgroundCanvas").css("top","0px"),$("#layoutBackgroundCanvas").attr("width",document.documentElement.clientWidth),$("#layoutBackgroundCanvas").attr("height",document.documentElement.clientHeight),$("#layoutBackgroundCanvas").width(document.documentElement.clientWidth),$("#layoutBackgroundCanvas").height(document.documentElement.clientHeight),$("#layoutBackgroundImage").removeClass("rotate90"),$("#layoutBackgroundImage").removeClass("rotate180"),$("#layoutBackgroundImage").removeClass("rotate270"),$("#layoutBackgroundImage").css("left","0px"),$("#layoutBackgroundImage").css("top","0px"),$("#layoutBackgroundImage").attr("width",document.documentElement.clientWidth),$("#layoutBackgroundImage").attr("height",document.documentElement.clientHeight),$("#layoutBackgroundImage").width(document.documentElement.clientWidth),$("#layoutBackgroundImage").height(document.documentElement.clientHeight),O.adjustLayoutViewDimensions(document.documentElement.clientWidth,document.documentElement.clientHeight)}function de(){logger.debug("Configuring Scheduled Reboots");try{if(null!=U&&clearTimeout(U),D.connectivity.scheduledRebootsEnabled){if(logger.debug("Scheduled Reboots Enabled"),null==D.connectivity.systemRebootTime)return void logger.error("System Reboot Time is Null. Cannot Configure Scheduled Reboots.");var e=0,t=l.now(),n=l.now().setTime(D.connectivity.systemRebootTime),o=l.now().setTime(D.connectivity.systemRebootTime).addDays(1);t.getTime()<n.getTime()?(e=n.getTime()-t.getTime(),logger.debug("Next Scheduled Reboot Today. Reboot Time: "+n.toLocaleString())):(e=o.getTime()-t.getTime(),logger.debug("Next Scheduled Reboot Tomorrow. Reboot Time: "+o.toLocaleString())),e>0&&(U=setTimeout(function(){r.reboot(I.SCHEDULED_REBOOT),logger.debug("Reboot Scheduled. Timeout (ms): "+e)},e+3e4))}else logger.debug("Scheduled Reboots Not Enabled.")}catch(e){logger.error(e.message)}}function ge(e){logger.info("Interrupt Triggered: "+e),y.triggerInterrupt(e,"KeyboardEvent",!1,!0)}function me(){logger.info("Starting Media Player"),K=!0,O.loadContent(D.content,D.synchronization,D.clientDetails),logger.info("Starting Web-based Interrupts"),J(),$.each(e.application.modules,function(e,t){if(t.supported&&t.enabled){var n="controllers/"+e.charAt(0).toUpperCase()+e.slice(1)+"Controller";require([n],function(n){n.initialize(t.options).done(function(){n.start().done(function(){logger.info("Module: "+e+" started.")}).fail(function(){logger.error("Error: Failed to start module: "+e)})}).fail(function(){logger.error("Error: Failed to initialize module: "+e)})})}})}function fe(t){logger.info("Stopping Media Player"),K=!1,O.stop(t),logger.info("Stopping Modules"),$.each(e.application.modules,function(e,t){if(t.supported&&t.enabled){var n="controllers/"+e.charAt(0).toUpperCase()+e.slice(1)+"Controller";require([n],function(t){t.stop().done(function(){logger.info("Module: "+e+" stopped")}).fail(function(){logger.warning("Error: Failed to stop module"+e)})})}})}try{chrome&&chrome.system&&chrome.system.display&&P.getDisplayInfo&&P.checkLastDisplayConfiguration&&P.setDOMProperties&&P.setLastDisplayConfiguration&&(P.getDisplayInfo().then(function(e){P.setLastDisplayConfiguration($("body").height(),$("body").width(),e.length)}),chrome.system.display.onDisplayChanged.addListener(function(){A||(A=!0,P.getDisplayInfo().then(function(e){logger.info("Displays connected: "+e.length);var t=e[0].bounds.height,n=e[0].bounds.width;0==P.checkLastDisplayConfiguration(t,n,e.length)?(logger.info("Last display configuration does not match current setup  --- Restarting media player ..."),P.setDOMProperties(t,n),P.setLastDisplayConfiguration(t,n,e.length),fe(),ue(),me()):logger.info("Last display configuration matches current setup"),P.loadDisplaySettings&&(logger.info("Reapplying display settings..."),P.loadDisplaySettings()),A=!1}))}))}catch(e){}}});