define(["models/FirmwareUpdateStatusConstants","properties/App.Settings"],function(r,t){return new function(){this.downloadFirmware=function(e){var r=$.Deferred();return logger.info("Beginning remote firmware download process..."),(new Storage).downloadFirmware(function(){logger.info("New remote firmware download successful"),r.resolve()},function(e){logger.error("Error downloading remote firmware: ["+e.errorCode+"] "+e.errorText),r.reject(e)},e),r},this.upgradeFirmware=function(){var e=$.Deferred();return logger.info("Beginning firmware upgrade process..."),(new Storage).upgradeFirmware(function(){logger.info("New firmware upgrade process started successfully."),e.resolve()},function(r){logger.error("Error upgrading to new firmware: ["+r.errorCode+"] "+r.errorText),e.reject(r)}),e},this.getFirmwareUpgradeStatus=function(){var e=$.Deferred();return logger.info("Checking firmware upgrade status..."),(new Storage).getFirmwareUpgradeStatus(function(r){logger.info("Firmware Upgrade Status: "+r.status),e.resolve(r)},function(t){logger.error("Error getting latest firmware update status: ["+t.errorCode+"] "+t.errorText),result.status=r.UNKNOWN,e.resolve(result)}),e},this.getSystemName=function(){var e=$.Deferred();return setTimeout(function(){logger.info("System Interface: System Name: LG WebOS Signage"),e.resolve("LG WebOS Signage")},100),e},this.getOSName=function(){var e=$.Deferred();return setTimeout(function(){logger.info("System Interface: OS Name: WebOS"),e.resolve("WebOS")},100),e},this.getOSVersion=function(){var e=$.Deferred();return(new Custom).Signage.getwebOSVersion(function(r){var t=r.webOSVersion;switch(t){case"1.0":case"2.0":case"3.0":case"3.2":case"4.0":case"4.1":case"5.0":logger.info("webOS Signage version: "+t),e.resolve(t);break;default:logger.warning("Unknown webOS Version: "+t),e.resolve(t)}},function(r){logger.error("Error loading webOS version using CustomJS: ["+r.errorCode+"]"+r.errorText);try{idcap.request("idcap://configuration/property/get",{parameters:{key:"webos_version"},onSuccess:function(r){logger.info("IDCAP WebOS Version Result = "+JSON.stringify(r)),e.resolve(r.value)},onFailure:function(r){logger.error("onFailure : errorMessage = "+r.errorMessage),e.resolve("Unknown")}})}catch(e){}}),e},this.getManufacturer=function(){var e=$.Deferred();return n().done(function(r){logger.info("System Interface: Manufacturer: "+r.manufacturer),e.resolve(r.manufacturer)}).fail(function(){e.reject()}),e},this.getModel=function(){var e=$.Deferred();return n().done(function(r){var t=r.modelName.split("-")[0];logger.info("System Interface: Model Name: "+t),e.resolve(t)}).fail(function(r){logger.error("Error getting model: ["+r.errorCode+"] "+r.errorText),e.reject()}),e},this.getSystemUpTime=function(){var e=$.Deferred();return function(){var e=$.Deferred();return(new Signage).getUsageData(function(r){logger.info("System Interface: System Usage Data Loaded"),e.resolve(r)},function(r){logger.error("System Interface: Error getting usage information. Error ["+r.errorCode+"] "+r.errorText),e.reject()}),e}().done(function(r){logger.info("System Interface: System Uptime: "+r.uptime+" hours"),e.resolve(r.uptime)}).fail(function(){e.reject()}),e},this.getTimeZone=function(){var e=$.Deferred();return setTimeout(function(){logger.warning("System Interface: Error: Get Time Zone Not Implemented."),e.reject()},100),e},this.getUTCOffset=function(){var e=$.Deferred();return setTimeout(function(){logger.warning("System Interface: Error: Get UTC Offset Not Implemented."),e.reject()},100),e},this.switchOffOSD=function(){var e=$.Deferred();return setTimeout(function(){logger.warning("System Interface: Error: Switch Off OSD Not Implemented."),e.reject()},100),e},this.getSDKVersion=function(){var e=$.Deferred();return n().done(function(r){logger.info("System Interface: SDK Version: "+r.sdkVersion),e.resolve(r.sdkVersion)}).fail(function(){e.reject()}),e},this.getFirmwareVersion=function(){var r=$.Deferred();return n().done(function(e){logger.info("System Interface: Firmware Version: "+e.firmwareVersion),r.resolve(e.firmwareVersion)}).fail(function(){logger.error("Error getting firmware version: ["+e.errorCode+"] "+e.errorText),r.reject()}),r},this.checkSupportedHTML5Features=function(e){if(!Modernizr)return $.Deferred.resolve({error:"Modernizr undefined. Unable to check features"});if(!1===Array.isArray(e))return $.Deferred.resolve({error:"Invalid parameter. Array of features to test expected."});var r={};return $.each(e,function(e,t){r[t+"_supported"]=Modernizr[t]}),$.Deferred().resolve(r)};var o=null;function n(){var e=$.Deferred();return(new DeviceInfo).getPlatformInfo(function(r){logger.info("System Interface: Platform Info Loaded"),e.resolve(r)},function(r){logger.error("System Interface: Error getting platform information. Error ["+r.errorCode+"] "+r.errorText),e.reject()}),e}this.getMaxSupportedTLSVersion=function(){if(o)return $.Deferred().resolve(o);var e=$.Deferred();if(t.application.features.supportsTLS12)var r={tls_version_string:t.application.ssl.maxSupportedTLSVersionString,tls_version:t.application.ssl.maxSupportedTLSVersion};else r={tls_version_string:t.application.ssl.legacyMaxSupportedTLSVersionString,tls_version:t.application.ssl.legacyMaxSupportedTLSVersion};return function(){var e=$.Deferred();try{logger.info("Calling out to Hows My SSL to check SSL details: "+t.application.ssl.sslCheckAPIUrl),$.ajax({url:t.application.ssl.sslCheckAPIUrl,type:"GET",contentType:"application/json",timeout:6e4}).done(function(r,t,o){logger.info("SSL API call successful: "+t),e.resolve(r)}).fail(function(r,t,o){logger.error("Error calling out to SSL API: "+t),e.reject()})}catch(r){logger.error("Error calling out to SSL API: "+r),e.reject()}return e}().done(function(t){r.detailed_tls_settings_included=!0,r.detailed_tls_settings=t,o=r,logger.info("Returning detailed TLS Info: "+JSON.stringify(r,void 0,2)),e.resolve(r)}).fail(function(){r.detailed_tls_settings_included=!1,r.detailed_tls_settings=null,logger.info("Returning basic TLS Info: "+JSON.stringify(r,void 0,2)),e.resolve(r)}),e},this.getOSDPortraitMode=function(){var e=$.Deferred();return function(){var e=$.Deferred();return(new Signage).getSignageInfo(function(r){logger.info("System Interface: Signage Info Loaded"),e.resolve(r)},function(r){logger.error("System Interface: Error getting signage information. Error ["+r.errorCode+"] "+r.errorText),e.reject()}),e}().done(function(r){e.resolve(r.portraitMode)}).fail(function(){e.reject()}),e},this.disableOSDPortraitMode=function(){var e=$.Deferred();logger.info("System Interface: DISABLING OSD...");var r={portraitMode:Signage.OsdPortraitMode.OFF};return(new Signage).setPortraitMode(function(r){logger.info("System Interface: OSD Potrait disabled"),e.resolve(r)},function(r){logger.error("System Interface: Error disabling OSD Potrait mode. Error ["+r.errorCode+"] "+r.errorText),e.reject()},r),e},this.enableOSDPortraitMode=function(){var e=$.Deferred(),r={portraitMode:Signage.OsdPortraitMode.ON};return(new Signage).setPortraitMode(function(r){logger.info("System Interface: OSD Potrait enabled"),e.resolve(r)},function(r){logger.error("System Interface: Error enabling OSD Potrait mode. Error ["+r.errorCode+"] "+r.errorText),e.reject()},r),e},this.setIDCAPProperty=function(e,r){var t=$.Deferred();return idcap.request("idcap://configuration/property/set",{parameters:{key:e,value:r},onSuccess:function(e){logger.info("setIDCAPProperty success = "+JSON.stringify(e)),t.resolve()},onFailure:function(e){logger.error("setIDCAPProperty failed - error = "+e.errorMessage),t.reject()}}),t},this.getIDCAPProperty=function(e){var r=$.Deferred();return idcap.request("idcap://configuration/property/get",{parameters:{key:e},onSuccess:function(e){logger.info("getIDCAPProperty = "+JSON.stringify(e)),r.resolve(e.value)},onFailure:function(e){logger.error("getIDCAPProperty failed - error = "+e.errorMessage),r.reject()}}),r},this.getServerProperties=function(){var e=$.Deferred();return logger.info("Loading server properties..."),(new Configuration).getServerProperty(function(r){logger.info("Server properties loaded"),e.resolve(r)},function(r){var t=r.errorCode,o=r.errorText;logger.error("Error Code ["+t+"]: "+o),e.reject()}),e},this.getPlayerType=function(){return"LG"},this.getFirmwareVersionSync=function(){return""}}});